<template>
  <div class="inline-flex flex-shrink-0 relative">
    <div v-if="Boolean(prefix)" class="pl-5 py-3 bg-grey prefix" :class="{ 'rounded-l-lg': prefix }">
      {{ prefix }}
    </div>
    <div>
      <Button
        class="bg-grey px-5 py-3 focus:outline-none focus:border-white prefix inline-flex items-center font-semibold"
        :class="{ 'rounded-l-lg': Boolean(!prefix) }"
        @click="open"
      >
        <span class="mr-2">{{ selected }}</span>
        <ChevronIcon />
      </Button>
      <transition name="slide-fade">
        <div v-if="isShow" class="mt-2 py-2 w-48 bg-white rounded-lg shadow-xl absolute menu" :class="{ show: isShow }">
          <div
            v-for="i in 5"
            :key="i"
            class="block px-4 py-2 text-gray-800 hover:bg-indigo-500 hover:text-white"
            @click="select('Lokasi' + i)"
          >
            Lokasi
          </div>
        </div>
      </transition>
    </div>
  </div>
</template>

<script>
const ChevronIcon = () => import('~/components/Icons/chevron');

export default {
  components: {
    ChevronIcon,
  },
  props: {
    prefix: {
      type: String,
      default: '',
    },
  },
  data: () => ({
    isShow: false,
    selected: 'Lokasi',
  }),
  mounted() {
    document.addEventListener('click', this.close);
  },
  beforeDestroy() {
    document.removeEventListener('click', this.close);
  },
  methods: {
    open() {
      this.isShow = !this.isShow;
    },
    select(v) {
      this.selected = v;
      this.isShow = false;
    },
    close(e) {
      if (!this.$el.contains(e.target)) {
        this.isShow = false;
      }
    },
  },
};
</script>

<style lang="scss" scoped>
.prefix {
  font-size: 12px;
  line-height: 18px;
  color: $black-alt;
  width: fit-content;
  flex-shrink: 0;
}
.bg-grey {
  background-color: $bg-grey;
}
.menu {
  cursor: pointer;
}
.slide-fade-enter-active {
  transition: all 0.3s ease;
}
.slide-fade-leave-active {
  transition: all 0.3s ease;
}
.slide-fade-enter,
.slide-fade-leave-to {
  transform: translateY(-5%);
  opacity: 0;
}
</style>
